/** @param {jQuery} $ jQuery Object */
!function($, window, document, _undefined)
{
    XF.NFDiscordWS = XF.Click.newHandler({
        eventNameSpace: 'XFNFDiscordWS',

        processing: false,

        init: function() {},

        click: function(e)
        {
            let sequence = 0;
            let token = this.$target.data('token');
            let socket = new WebSocket('wss://gateway.discord.gg/?encoding=json&v=6');

            socket.onopen = function() { console.log('Discord: Attempting to open WebSocket'); },
                socket.onerror = function(err) { console.error(err); },
                socket.onclose = function(err) { console.error(err); },
                socket.onmessage = function(msg)
                {
                    try
                    {
                        let data = JSON.parse(msg.data);
                        sequence = data.s;

                        if (data.op === 10)
                        {
                            console.log('Discord: Sending handshake');
                            socket.send(JSON.stringify({
                                op: 2,
                                d: {
                                    token: token,
                                    properties: {
                                        $browser: 'NixBot for XenForo',
                                        $device: 'NixBot',
                                        $referrer: '',
                                        $referring_domain: '',
                                    },
                                    large_threshold: 5
                                }
                            })),
                                setInterval(function() {
                                    console.log('Discord: Sending heartbeat (' + sequence + ')');
                                    socket.send(JSON.stringify({
                                            op: 1,
                                            d: sequence
                                        })
                                    )
                                }, data.d.heartbeat_interval);
                        }
                    }
                    catch (err)
                    {
                        console.error(err);
                    }
                };

            XF.flashMessage('WebSocket opened', 3000);
        },
    });

    XF.Click.register('websocket', 'XF.NFDiscordWS');
}
(jQuery, this, document);