<?php

namespace NF\Discord\Cron;

class ReportNotifications
{
	public static function pushPeriodic()
	{
		$addOns = \XF::app()->container('addon.cache');
		if (empty($addOns['NF/Discord']) || empty($addOns['SV/ReportCentreEssentials']))
		{
			return;
		}

		/** @var \SV\ReportCentreEssentials\Repository\ReportQueue $reportQueueRepo */
		$reportQueueRepo = \XF::repository('SV\ReportCentreEssentials:ReportQueue');
		$reportQueues = $reportQueueRepo->getReportQueues();
		foreach ($reportQueues as $queue)
		{
			/** @var \NF\Discord\SV\ReportCentreEssentials\Entity\ReportQueue $queue */
			if (!$queue->nf_discord_channel_id)
			{
				continue;
			}
			if ($queue->nf_discord_open_threshold && $queue->nf_discord_open_count)
			{
				$time = \XF::$time - $queue->nf_discord_open_threshold * 60;
				if ($time >= $queue->nf_discord_open_timestamp)
				{
					\XF::app()->jobManager()->enqueueUnique('nfd-too-many-reports.' . $queue->queue_id, 'NF\Discord:NotifyTooManyOpenReports', [
						'queueId' => $queue->queue_id,
					], false);
				}
			}

			if ($queue->nf_discord_old_report_first_threshold)
			{
				if ($queue->nf_discord_old_report_repeating)
				{
					$time = \XF::$time - $queue->nf_discord_old_report_repeat_threshold * 60;
				}
				else
				{
					$time = \XF::$time - $queue->nf_discord_old_report_first_threshold * 60 * 60;
				}
				if ($time >= $queue->nf_discord_old_report_timestamp)
				{
					\XF::app()->jobManager()->enqueueUnique('nfd-old-open-reports.' . $queue->queue_id, 'NF\Discord:NotifyOldOpenReports', [
						'queueId' => $queue->queue_id,
					], false);
				}
			}
		}
	}
}