<?php

namespace NF\Discord;

class InstallerListener
{
	public static function addOnPostRebuild(
		/** @noinspection PhpUnusedParameterInspection */
		\XF\AddOn\AddOn $addOn, \XF\Entity\AddOn $installedAddOn, array $json)
	{
		if (empty(Setup::$supportedAddOns[$addOn->getAddOnId()]))
		{
			return;
		}

		// kick off the installer
		$setup = new Setup($addOn, \XF::app());
		$setup->applySchemaUpdates();
	}

	public static function addOnPostInstall(
		/** @noinspection PhpUnusedParameterInspection */
		\XF\AddOn\AddOn $addOn, \XF\Entity\AddOn $installedAddOn, array $json, array &$stateChanges)
	{
		if (empty(Setup::$supportedAddOns[$addOn->getAddOnId()]))
		{
			return;
		}

		// kick off the installer
		$setup = new Setup($addOn, \XF::app());
		$setup->applySchemaUpdates();
	}
}