<?php

namespace NF\Discord\Option;

use NF\Discord\Api;
use XF\Option\AbstractOption;

class Channels extends AbstractOption
{
	public static function renderOption(\XF\Entity\Option $option, array $htmlParams)
	{
		$provider = \XF::app()->em()->find('XF:ConnectedAccountProvider', 'nfDiscord');

		if (!$provider->options['guild_id'] || !$provider->options['token'])
		{
			return self::getTemplate('admin:nf_discord_option_channels', $option, $htmlParams, ['invalid' => true]);
		}

		$api = Api::factory();

		$channels = $api->getChannels(Api::CHANNEL_TYPE_TEXT);

		return self::getTemplate('admin:nf_discord_option_channels', $option, $htmlParams, ['channels' => $channels]);
	}

	public static function verifyOption(array &$groups, \XF\Entity\Option $option, $optionId)
	{
		// TODO: Add verify that channel exists.
	}
}