<?php

namespace NF\Discord\Option;

use NF\Discord\Api;
use XF\Option\AbstractOption;

class Roles extends AbstractOption
{
	public static function renderOption(\XF\Entity\Option $option, array $htmlParams)
	{
		$provider = \XF::app()->em()->find('XF:ConnectedAccountProvider', 'nfDiscord');

		if (!$provider->options['guild_id'] || !$provider->options['token'])
		{
			return self::getTemplate('admin:nf_discord_option_roles', $option, $htmlParams, ['invalid' => true]);
		}

		$api = Api::factory();

		$roles = $api->getRoles(false);

		return self::getTemplate('admin:nf_discord_option_roles', $option, $htmlParams, ['roles' => $roles]);
	}

	public static function verifyOption(array &$groups, \XF\Entity\Option $option, $optionId)
	{
		// TODO: Add verify that role exists.
	}
}