<?php

namespace NF\Discord\XF\Admin\Controller;

/*
 * Extends \XF\Admin\Controller\Tools
 */

use NF\Discord\Api;

class Tools extends XFCP_Tools
{
	public function actionTestDiscord()
	{
		$api = Api::factory();
		$provider = $api->getDiscordConfiguration();

		$tested = false;
		$link = false;
		$checks = [];
		$guild = [];
		$bot = [];

		if ($this->filter('test', 'int'))
		{
			$tested = true;
			$bot = $api->getCurrentUser();
			$guild = $api->getGuild();
			$link = $api->getBotAuthorizeLink();

			$checks['canConnect'] = (isset($guild['id']) ? true : false);
			$checks['botPresent'] = $api->isMemberOfGuild(isset($guild['id']) ? $guild['id'] : 0);
			$checks['widgetEnabled'] = $api->isWidgetEnabledForGuild($guild);

			if ($this->filter('debug', 'int'))
			{
				\XF::dump($bot);
				\XF::dump($guild);
				die();
			}
		}

		$viewParams = [
			'provider' => $provider,
			'tested' => $tested,
			'link' => $link,
			'bot' => $bot,
			'guild' => $guild,
			'checks' => $checks,
		];
		return $this->view(
			'NF\Discord:Tools\TestIntegration',
			'nf_discord_test_integration',
			$viewParams
		);
	}
}
