<?php

namespace NF\Discord\XF\Entity;

use XF\Mvc\Entity\Structure;

/**
 * Extends \XF\Entity\Forum
 *
 * @property string nf_discord_channel_id
 * @property bool nf_discord_include_replies
 */
class Forum extends XFCP_Forum
{
	public static function getStructure(Structure $structure)
	{
		$structure = parent::getStructure($structure);

		$structure->columns['nf_discord_channel_id'] = ['type' => self::STR, 'max' => 64, 'default' => 0];
		$structure->columns['nf_discord_include_replies'] = ['type' => self::BOOL, 'default' => false];

		return $structure;
	}
}
