<?php

namespace NF\Discord\XF\Entity;

use NF\Discord\Globals;
use XF\Mvc\Entity\Structure;

/**
 * Extends \XF\Entity\ForumWatch
 *
 * @property boolean send_discord
 */
class ForumWatch extends XFCP_ForumWatch
{
	public function _preSave()
	{
		if (Globals::$forumWatchDiscord !== null)
		{
			$this->send_discord = Globals::$forumWatchDiscord;
		}

		parent::_preSave();
	}

	public static function getStructure(Structure $structure)
	{
		$structure = parent::getStructure($structure);

		$structure->columns['send_discord'] = ['type' => self::BOOL, 'default' => false];

		return $structure;
	}
}
