<?php

namespace NF\Discord\XF\Entity;

use NF\Discord\Helper;
use XF\Mvc\Entity\Structure;

/**
 * Extends \XF\Entity\User
 */
class User extends XFCP_User
{
	public function canLinkDiscordAccount()
	{
		return $this->hasPermission('discord', 'linkAccount');
	}

	protected function _postSave()
	{
		if ($this->isChanged('user_group_id')
			|| $this->isChanged('secondary_group_ids')
			|| $this->isChanged('username')
		)
		{
			$linkedDiscord = $this->ConnectedAccounts['nfDiscord'];

			if ($linkedDiscord)
			{
				$helper = Helper::factory();
				$helper->setUserServerGroupsByConnectedAccount($linkedDiscord);
			}
		}

		parent::_postSave();
	}

	protected function _postDelete()
	{
		$linkedDiscord = $this->ConnectedAccounts['nfDiscord'];

		// we delete this here before XF blindly nukes all the connected account records
		if ($linkedDiscord && \XF::options()->nfDiscordAssocKickServer)
		{
			$helper = Helper::factory();
			$helper->kickUserFromServer($linkedDiscord->provider_key);
		}

		parent::_postDelete();
	}
}