<?php

namespace NF\Discord\XF\Entity;

use NF\Discord\Api;
use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * Extends \XF\Entity\UserAlert
 */
class UserAlert extends XFCP_UserAlert
{
	protected function _postSave()
	{
		parent::_postSave();

		if ($this->canView()
			&& $discord = $this->Receiver->ConnectedAccounts['nfDiscord']
		)
		{
			/** @var \NF\Discord\XF\Entity\UserOption $userOption */
			$userOption = $this->Receiver->Option;
			if ($userOption->doesReceiveDiscordMessage($this->content_type, $this->action))
			{
				\XF::runLater(function () use ($discord)
				{
					$api = Api::factory(false);
					if ($api)
					{
						$messageContent = strip_tags($this->render());
						$messageContent = html_entity_decode($messageContent, ENT_QUOTES);

						$dm = $api->createDM($discord['provider_key']);
						$api->createMessage($dm['id'], '', [
							'footer' => [
								'text' => \XF::options()->boardTitle,
							],
							'url' => \XF::app()->router('public')->buildLink('full:account/alerts'),
							'title' => $messageContent,
							'timestamp' => date('c', $this->event_date),
						]);
					}
				});
			}
		}
	}
}