<?php

namespace NF\Discord\XF\Entity;

use NF\Discord\Api;
use NF\Discord\Helper;

class UserConnectedAccount extends XFCP_UserConnectedAccount
{
	protected function _postSave()
	{
		parent::_postSave();

		if ($this->provider == 'nfDiscord' && $this->User)
		{
			$helper = Helper::factory();
			$helper->setUserServerGroupsByConnectedAccount($this);
		}
	}

	protected function _postDelete()
	{
		parent::_postDelete();

		if ($this->provider == 'nfDiscord' && $this->User)
		{
			\XF::runLater(function ()
			{
				$helper = Helper::factory();

				if (\XF::options()->nfDiscordAssocKickServer)
				{
					$helper->kickUserFromServer($this->provider_key);
				}
				else
				{
					$api = Api::factory(false);
					$siteRoles = $helper->getUserRoles($this->User, $this->provider_key, false);
					$userRoles = $helper->getMemberRoles($this->provider_key);

					$roles = array_filter($userRoles, function ($role) use ($siteRoles)
					{
						return !in_array($role, $siteRoles);
					});

					$api->patchGuildMemberRoles($this->provider_key, $roles);
				}
			});
		}
	}
}