<?php

namespace NF\Discord\XF\Entity;

use XF\Mvc\Entity\Entity;
use XF\Mvc\Entity\Structure;

/**
 * Extends \XF\Entity\UserOption
 *
 * @property array|null nf_discord_optout
 */
class UserOption extends XFCP_UserOption
{
	public function doesReceiveDiscordMessage($contentType, $action)
	{
		$optouts = is_null($this->nf_discord_optout) ? [] : $this->nf_discord_optout;
		return in_array("{$contentType}_{$action}", $optouts) ? false : true;
	}

	/**
	 * @param Structure $structure
	 *
	 * @return Structure
	 */
	public static function getStructure(Structure $structure)
	{
		$structure = parent::getStructure($structure);

		$structure->columns['nf_discord_optout'] = [
			'type' => self::LIST_COMMA,
			'default' => [],
			'nullable' => true,
			'list' => ['type' => 'str', 'unique' => true, 'sort' => true],
			'changeLog' => false,
		];

		return $structure;
	}
}