<?php

namespace NF\Discord\XF\Pub\Controller;

use XF\Mvc\FormAction;
use XF\Mvc\Reply\View;

/**
 * Extends \XF\Pub\Controller\Account
 */
class Account extends XFCP_Account
{
	public function actionPreferences()
	{
		$reply = parent::actionPreferences();
		if ($reply instanceof View)
		{
			$reply->setParam('canMirrorDiscordAlerts', $this->canMirrorDiscordAlerts());
		}
		return $reply;
	}

	protected function preferencesSaveProcess(\XF\Entity\User $visitor)
	{
		$form = parent::preferencesSaveProcess($visitor);

		if ($this->canMirrorDiscordAlerts())
		{
			$alertRepo = $this->repository('XF:UserAlert');
			$optOutActions = $alertRepo->getAlertOptOutActions();
			$discord = $this->filter('nf_discord', 'array-bool');

			$discordOptOuts = [];
			foreach (array_keys($optOutActions) AS $optOut)
			{
				if (empty($discord[$optOut]))
				{
					$discordOptOuts[$optOut] = $optOut;
				}
			}

			$form->setup(function (FormAction $form) use ($discordOptOuts, $visitor)
			{
				$visitor->Option->nf_discord_optout = $discordOptOuts;
			});
		}

		return $form;
	}

	protected function canMirrorDiscordAlerts()
	{
		if (empty(\XF::visitor()->ConnectedAccounts['nfDiscord']))
		{
			return false;
		}

		return true;
	}
}