<?php

namespace NF\Discord\XF\Pub\Controller;

class Login extends XFCP_Login
{
	public function actionIndex()
	{
		$response = parent::actionIndex();

		if ($response instanceof \XF\Mvc\Reply\View)
		{
			if (!\XF::options()->nfDiscordAllowDiscordLogin)
			{
				/** @var \XF\Mvc\Entity\ArrayCollection $providers */
				$providers = $response->getParam('providers');

				if ($providers
					&& $providers->count()
					&& $providers->offsetExists('nfDiscord')
				)
				{
					$providers->offsetUnset('nfDiscord');
					$response->setParam('providers', $providers);
				}
			}
		}

		return $response;
	}

	public function actionLogin()
	{
		$response = parent::actionLogin();

		if ($response instanceof \XF\Mvc\Reply\View)
		{
			if (!\XF::options()->nfDiscordAllowDiscordLogin)
			{
				/** @var \XF\Mvc\Entity\ArrayCollection $providers */
				$providers = $response->getParam('providers');

				if ($providers
					&& $providers->count()
					&& $providers->offsetExists('nfDiscord')
				)
				{
					$providers->offsetUnset('nfDiscord');
					$response->setParam('providers', $providers);
				}
			}
		}

		return $response;
	}
}