<?php

namespace NF\Discord\XFRM\Service\ResourceItem;

use NF\Discord\Api;

/**
 * Extends \XFRM\Service\ResourceItem\Create
 */
class Create extends XFCP_Create
{
	public function sendNotifications()
	{
		parent::sendNotifications();

		$resource = $this->resource;
		$category = $this->category;

		if ($resource->isVisible() && !empty($category->nf_discord_channel_id))
		{
			$description = $this->description;

			$url = \XF::app()->router('public')->buildLink('full:resources', $resource);
			$phrase = \XF::phrase('nfDiscord_notice.xfrm_resource_new', [
				'username' => $resource->username,
				'title' => $resource->title,
				'category' => $category->title,
				'url' => $url,
			]);

			$snippet = $this->app->stringFormatter()->stripBbCode($description->message, [
				'stripQuote' => false,
			]);
			$snippet = $this->app->stringFormatter()->wholeWordTrim($snippet, 500);

			$api = Api::factory(false);
			if ($api)
			{
				$api->createMessage($category->nf_discord_channel_id, $phrase->render('raw'), [
					'author' => [
						'name' => $resource->username,
						'url' => \XF::app()->router('public')->buildLink('full:members', $resource->User),
					],
					'footer' => [
						'text' => $category->title,
					],
					'title' => $resource->title,
					'url' => $url,
					'description' => $snippet,
					'timestamp' => date('c', $resource->resource_date),
				]);
			}
		}
	}
}